#include "lib.h"
#include "oled.h"
#include "intrins.h"

unsigned char WAVE_DATA[3 * 16] = {24, 27, 30, 33, 35, 38, 40, 43, 44, 46, 47, 47, 47, 47, 47, 46, 44, 43, 40, 38, 36, 33, 30, 27, 24, 20, 17, 14, 12, 9, 7, 4, 3, 1, 0, 0, 0, 0, 0, 1, 3, 4, 6, 9, 11, 14, 17, 20}; //ݴ沨
float VMAX = 0; //ݴźŷֵѹ
float GAIN = 1.0; //ݴŴ
float OFST = 0.0; //ݴƫ

unsigned char FREQ = 0; //ݴPWMƵ
float CALC;//ݴĵѹ

void Timer0Init(void)
{
    TMOD = 0x00;                                //ģʽ0
    TL0 = 0x66;                                 //65536-11.0592M/12/1000
    TH0 = 0xfc;
    TR0 = 1;                                    //ʱ
    ET0 = 1;                                    //ʹܶʱж
    EA = 1;
}

void TM0_Isr() interrupt 1
{
    //ADCģʽ裬Ȼȡݷŵʱлź
    static unsigned char COUNT = 0;
    COUNT++;

    if(COUNT / 100)
    {
        COUNT = 0;
        EADC = 0;//ʱرADCж
        ENABLE_ADC_FRE;//ӦADCѹ
        ADC_CONTR |= 0x40;                      //ADת
        _nop_();
        _nop_();

        while (!(ADC_CONTR & 0x20));            //ѯADCɱ־

        ADC_CONTR &= ~0x20;                     //ɱ־
        FREQ = ADC_RES;                           //ȡADC
        EADC = 1;//ָADCж
        ENABLE_ADC_SIG;
    }
}

void SET_DAC(unsigned char DAC_TEMP)
{
//    unsigned char TEMP;
//    DAC_TEMP = DAC_TEMP * 5.0 / 256.0;
//    TEMP = DAC_TEMP;
    DAC0_PIN = GET_BIT(DAC_TEMP, 0);
    DAC1_PIN = GET_BIT(DAC_TEMP, 1);
    DAC2_PIN = GET_BIT(DAC_TEMP, 2);
    DAC3_PIN = GET_BIT(DAC_TEMP, 3);

    DAC4_PIN = GET_BIT(DAC_TEMP, 4);
    DAC5_PIN = GET_BIT(DAC_TEMP, 5);
    DAC6_PIN = GET_BIT(DAC_TEMP, 6);
    DAC7_PIN = GET_BIT(DAC_TEMP, 7);
}

void GPIO_INIT()
{
    P1M0 = 0xFF;
    P1M1 = 0x00;
    P3M0 = 0x00;                                //P3.3 P3.4ΪADC
    P3M1 = 0x1C;
}

void ADC_Isr() interrupt 5
{
    float Temp;
    ADC_CONTR &= ~0x20;                         //жϱ־
    Temp = GAIN * ADC_RES;
    SET_DAC(Temp);                           //ȡADC

    Temp = ADC_RES / 51.2;

    if(Temp > VMAX)VMAX = Temp;

    ADC_CONTR |= 0x40;                          //ADת
}

//void PrintData()
//{
//    OLED_ShowNum(50, 6, ADC_RES, 3, 16);
//}

void ADC_INIT_ENABLE()
{
    EADC = 1;                                   //ʹADCж
    EA = 1;
}

void SET_ADC_DIV(unsigned char Temp)
{
    ADCCFG = Temp % 16;
}

void PRINT_POINT(unsigned char x, unsigned char y, unsigned char status)
{
    //status=1ʱӦ
    OLED_Set_Pos(x, (63 - y) / 8);
    OLED_WR_Byte(status << ((63 - y) % 8), OLED_DATA);
}

void PRINT_WAVE()
{
    //Ʋ
    int PRINT_WAVE_TEMP_X = 1, PRINT_WAVE_TEMP_Y = 1;

    //ղ
//    for(PRINT_WAVE_TEMP_X = 0; PRINT_WAVE_TEMP_X < 16 * 3; PRINT_WAVE_TEMP_X++)
//        for(PRINT_WAVE_TEMP_Y = 0; PRINT_WAVE_TEMP_Y < 64 - 16; PRINT_WAVE_TEMP_Y++)
//            PRINT_POINT(PRINT_WAVE_TEMP_X, PRINT_WAVE_TEMP_Y, 0);

    for(PRINT_WAVE_TEMP_X = 0; PRINT_WAVE_TEMP_X < 16 * 3; PRINT_WAVE_TEMP_X++)
        for(PRINT_WAVE_TEMP_Y = 0; PRINT_WAVE_TEMP_Y < 64 - 16; PRINT_WAVE_TEMP_Y++)
        {
            if(PRINT_WAVE_TEMP_Y == WAVE_DATA[PRINT_WAVE_TEMP_X])
                PRINT_POINT(PRINT_WAVE_TEMP_X, PRINT_WAVE_TEMP_Y, 1);
        }
}

void CHANGE_GAIN()
{
    if(VMAX < GAIN_HIGH_LEVEL)
    {
        if(VMAX < GAIN_LOW_LEVEL)
            GAIN = 10; //ѹСGAIN_LOW_LEVELʱ򣬷ŴΪ10
        else
            GAIN = 2; //ѹСGAIN_HIGH_LEVELʱ򣬷ŴΪ2
    }
    else
        GAIN = 0.5; //ѹGAIN_HIGH_LEVELʱ򣬷ŴΪ0.5
}

void PRINT_DATA()
{
    unsigned int temp;
    //OLED_Clear();//ᵼ˸Ӱ
    PRINT_WAVE();
    OLED_ShowCHinese(0, 0, 0);
    OLED_ShowCHinese(18, 0, 1);
    OLED_ShowCHinese(36, 0, 2);
    OLED_ShowCHinese(54, 0, 3);
    OLED_ShowCHinese(72, 0, 4);
    OLED_ShowCHinese(90, 0, 5);
    OLED_ShowCHinese(108, 0, 6);
    OLED_ShowString(54, 2, "VMAX:", 12);
    OLED_ShowString(54, 3, "GAIN:", 12);
    OLED_ShowString(54, 4, "OFST:", 12);
    OLED_ShowString(54, 5, "MYFPGA.CN", 12);
    OLED_ShowString(54, 6, "LIGH:", 12);
    OLED_ShowString(54, 7, "CALC:", 12);
    //ʵʱ
    temp = VMAX * 100;
    OLED_ShowNum(92, 2, temp, 5, 12); //ʾASCIIֵַ
    temp = GAIN * 100;
    OLED_ShowNum(92, 3, temp, 4, 12); //ʾASCIIֵַ
    OLED_ShowChar(127 - 11, 3, ' ' + 5, 12); //ʾ%
    temp = OFST * 100;
    OLED_ShowNum(92, 4, temp, 4, 12); //ʾASCIIֵַ
    OLED_ShowChar(127 - 11, 4, ' ' + 5, 12); //ʾ%

    OLED_ShowNum(92, 6, FREQ, 5, 12); //ʾASCIIֵַ
    CALC = FREQ / 51.2;
    temp = CALC * 100;
    OLED_ShowNum(92, 7, temp, 5, 12); //ʾASCIIֵַ
    CHANGE_GAIN();
}

void Delay5ms()		//@12.000MHz
{
	unsigned char i, j;

	_nop_();
	_nop_();
	i = 78;
	j = 233;
	do
	{
		while (--j);
	} while (--i);
}

void SYSTEM_INIT()
{
    //DACʹADCɼʾĻ
    unsigned char TEMP_DAC, TEMP_ADC;
		float TEMP_OFST;
    OLED_Init();
    OLED_Clear();
    OLED_ShowString(0, 0, "MYFPGA.CN", 16);
    OLED_ShowString(0, 2, "Calibrating...", 12);
    SET_ADC_DIV(1);//ADCΪȫ
    ENABLE_ADC_V;

    for(TEMP_DAC = 0; TEMP_DAC < 255; TEMP_DAC++)
    {
        SET_DAC(TEMP_DAC);//õѹ
        ADC_CONTR |= 0x40;                          //ADת
        _nop_();
        _nop_();
        while (!(ADC_CONTR & 0x20));            //ѯADCɱ־
        ADC_CONTR &= ~0x20;                     //ɱ־
        TEMP_ADC = ADC_RES;                           //ȡADC
				OLED_ShowNum(45, 4, TEMP_DAC, 5, 12); //DAC
				OLED_ShowNum(45, 5, TEMP_ADC, 5, 12); //DAC
			
				//
				if(TEMP_DAC>TEMP_ADC)
					TEMP_OFST=(TEMP_DAC-TEMP_ADC)/TEMP_ADC;
				else if(TEMP_DAC<TEMP_ADC)
					TEMP_OFST=(TEMP_ADC-TEMP_DAC)/TEMP_DAC;
				
				if(TEMP_OFST>OFST)OFST=TEMP_OFST;
				Delay5ms();
    }
}