#include "STC8.H"

#define ADC_SIG 10
#define ADC_V 	11
#define ADC_FRE 12
#define ADC_REF 15

#define GAIN_HIGH_LEVEL 2.5
#define GAIN_LOW_LEVEL 0.5

#define ENABLE_ADC_SIG	 ADC_CONTR = 0x8A;
#define ENABLE_ADC_V		 ADC_CONTR = 0x8B;
#define ENABLE_ADC_FRE	 ADC_CONTR = 0x8C;
#define ENABLE_ADC_REF	 ADC_CONTR = 0x8F;

#define START_ADC_SIG	 	 ADC_CONTR = 0x4A;
#define START_ADC_V			 ADC_CONTR = 0x4B;
#define START_ADC_FRE		 ADC_CONTR = 0x4C;
#define START_ADC_REF		 ADC_CONTR = 0x4F;

#define DAC7_PIN P17
#define DAC6_PIN P16
#define DAC5_PIN P15
#define DAC4_PIN P11
#define DAC3_PIN P12
#define DAC2_PIN P13
#define DAC1_PIN P14
#define DAC0_PIN P10


#define	GET_BIT(x, bit)	((x & (1 << bit)) >> bit)

void SYSTEM_INIT();
void PRINT_WAVE();
void PRINT_DATA();
void GPIO_INIT();
//void PrintData();
void Timer0Init(void);
void ADC_INIT_ENABLE();
void SET_ADC_DIV(unsigned char Temp);
void SET_DAC(unsigned char DAC_TEMP);
void PRINT_POINT(unsigned char x, unsigned char y, unsigned char status);